/*
 * Copyright (c) 2005 DocJava, Inc. All Rights Reserved.
 */
package j2d.color;

import j2d.FloatImageProcessorInterface;
import math.Mat3;

import javax.vecmath.Matrix3d;
import java.awt.*;

/**
 * Copyright DocJava, inc. User: lyon
 * <p/>
 * Date: Apr 21, 2005
 * <p/>
 * Time: 9:04:21 AM
 */
//todo I was playing with IYQ and started to narrow the color coordinates
//todo for cr311 hw8 please narrow them down further.
// use any color space you like except rgb. You might try hsv
// then just focus on hue.
public class FloatColorConverterInterface implements FloatImageProcessorInterface {
    public static void main(String[] args) {
        video.Pantomation.testChromaKeyTag();
    }

    private Mat3 m;

    public FloatColorConverterInterface(Mat3 m) {
        this.m = m;
    }

    public FloatColorConverterInterface(Matrix3d m3d) {
        m = new Mat3(m3d);
    }

    public FloatImageBean process(FloatImageBean fib) {
        FloatImageBean newFib = new FloatImageBean(fib.getWidth(), fib.getHeight());
        float pel[];
        for (int x = 0; x < fib.getWidth(); x++)
            for (int y = 0; y < fib.getHeight(); y++) {
                pel = m.multiply(fib.getR()[x][y], fib.getG()[x][y], fib.getB()[x][y]);

                newFib.getR()[x][y] = pel[0];
                newFib.getG()[x][y] = pel[1];
                newFib.getB()[x][y] = pel[2];
            }
        return newFib;
    }

    public Image process(Image image) {
        FloatImageBean fib = new FloatImageBean(image);
        return process(fib).getImage();
    }
}
